;-------------------------------------------------------------------------------
;
; Name        : CatchExeIcon
; Version     : 1.0
;
; Author      : Flype ( flype@altern.org )
; Date        : 08 may 2004
;
; Purpose     : CatchExeIcon provide an easy access to the executable's icon
;
; Compatibily : Designed for Microsoft Windows only
; Compilation : TailBite 1.1 PR 10 and PureBasic 3.90
;
; Commands    : hIcon.l = CatchExeBigIcon()
;               hIcon.l = CatchExeSmallIcon()
;
;-------------------------------------------------------------------------------




;-------------------------------------------------------------------------------
; Library Initialisation
;-------------------------------------------------------------------------------


ProcedureDLL CatchExeIcon_Init()
  
  Global ExeNamePtr.l
  
  ExeNamePtr = AllocateMemory(255)
  GetModuleFileName_(0, ExeNamePtr, 255)
  
EndProcedure


;-------------------------------------------------------------------------------
; Private commands
;-------------------------------------------------------------------------------


Procedure.l CatchExeIcon(Flags.l)
  
  SHGetFileInfo_(ExeNamePtr, #Null, @InfosFile.SHFILEINFO, SizeOf(SHFILEINFO), #SHGFI_ICON | Flags)
  ProcedureReturn InfosFile\hIcon
  
EndProcedure


;-------------------------------------------------------------------------------
; Public commands
;-------------------------------------------------------------------------------


ProcedureDLL.l CatchExeBigIcon()
  
  ProcedureReturn CatchExeIcon(#SHGFI_LARGEICON)
  
EndProcedure


ProcedureDLL.l CatchExeSmallIcon()
  
  ProcedureReturn CatchExeIcon(#SHGFI_SMALLICON)
  
EndProcedure


;-------------------------------------------------------------------------------
; End of library
;-------------------------------------------------------------------------------


ProcedureDLL CatchExeIcon_End()
  
  FreeMemory(ExeNamePtr)
  
EndProcedure

; ExecutableFormat=Windows
; EOF